#!/usr/bin/env python
from __future__ import generators
import findrox; findrox.version(1,9,12)
import rox
from rox import applet, g, Menu, InfoWin, tasks, ButtonMixed, choices, options
from rox.Menu import Menu, set_save_name
from rox.options import Option
import sys

from xml.dom import minidom
import xml.sax
import urllib

import gc
import os
import re
import gobject

#import choices

program = "RETicker"
set_save_name(program)
rox.setup_app_options(program)

update_time = Option('update_time', '10') # in sec.
refresh_time= Option('refresh_time', '20') # in Min
browser= Option('browser', 'opera')
br_options= Option('br_options', '-newpage')
check_verbose=Option('check_verbose', '1')
check_image=Option('check_image', '0')
hor_size=Option('hor_size', '-1')
ver_size=Option('ver_size', '20')
try:
	path = os.environ['CHOICESPATH']
	paths = path.split(':')
except KeyError:
	paths = [ os.environ['HOME'] + '/Choices',
		  '/usr/local/share/Choices',
		  '/usr/share/Choices' ]
cache = paths[0] + '/' + program
if not(os.path.exists(cache)): os.mkdir(cache)
cache += "/icon_cache"
if not(os.path.exists(cache)): os.mkdir(cache)
cache_dir=Option('cache_dir', cache)

tt_l=Option('tt_l', '1') # zeigt Label-ToolTip mit Description an
tt_l_frame=Option('tt_l_frame', '1')
tt_l_title=Option('tt_l_title', '1')
tt_l_link=Option('tt_l_link', '1')
tt_l_ver=Option('tt_l_ver', '1')

tt_i=Option('tt_i', '1') # zeigt Image-ToolTip mit Description an
tt_i_frame=Option('tt_i_frame', '1')
tt_i_title=Option('tt_i_title', '1')
tt_i_desc=Option('tt_i_desc', '1')
tt_i_src=Option('tt_i_src', '1')
tt_i_link=Option('tt_i_link', '1')
tt_i_ver=Option('tt_i_ver', '1')

sources=Option('sources', "<Options><source><active>1</active><ticker>http://slashdot.org/slashdot.rdf</ticker><icon>http://slashdot.org/favicon.ico</icon><iconcache></iconcache><maxnews>23</maxnews><fetchicon>0</fetchicon></source></Options>")
rox.app_options.notify()


program = "RETicker"
leaf 	= "RE_Ticker_sources"
#path = choices.load(program, leaf)


def unxml(string):
	""" removes entities from a given string and returns new string """
	lt=re.compile('&lt;')
	gt=re.compile('&gt;')
	amp=re.compile('&amp;')
	auml=re.compile('&auml;|&#228;')
	Auml=re.compile('&Auml;')
	ouml=re.compile('&ouml;|&#246;')
	Ouml=re.compile('&Ouml;')
	uuml=re.compile('&uuml;|&#252;')
	Uuml=re.compile('&Uuml;')
	szlig=re.compile('&szlig;|&#223;')
	quot=re.compile('&quot;')
	apos=re.compile('&apos;')
	#tag=re.compile('<.*?>')
	(string,null)=amp.subn("&",string,0)
	(string,null)=auml.subn(u'\xE4',string,0)
	(string,null)=Auml.subn(u'\xC4',string,0)
	(string,null)=ouml.subn(u'\xF6',string,0)
	(string,null)=Ouml.subn(u'\xD5',string,0)
	(string,null)=Uuml.subn(u'\xDC',string,0)
	(string,null)=szlig.subn(u'\xDF',string,0)
	(string,null)=uuml.subn(u'\xFC',string,0)
	(string,null)=quot.subn('"',string,0)
	(string,null)=apos.subn("'",string,0)
	(string,null)=lt.subn("<",string,0)
	(string,null)=gt.subn(">",string,0)
	#(string,null)=tag.subn("",string,0)
	return string


import rox.OptionsBox
from rox.OptionsBox import data
class OptionsBox(rox.OptionsBox.OptionsBox):
	def build_image(self, node, image):
		"""<image>Text</image>"""
		image = g.Image()
		Filename = rox.app_dir + "/" + data(node)
    		if os.path.exists(Filename):
    			image.set_from_file(Filename)
		else:
			image.set_from_stock(g.STOCK_MISSING_IMAGE,g.ICON_SIZE_SMALL_TOOLBAR)
		return [image]	

	def build_tickerconf(self, node, label, option):
		"""<tickerconf>(u"Hallo","Hallo2")</tickerconf>"""
		PrefTab = TickPrefs_Container()
		self.may_add_tip(PrefTab, node)
		PrefTab.connect('changed_Conti', lambda t,w: self.check_widget(option))
		def get():
			return PrefTab.get_value()
		def set():
			PrefTab.load_config(option.value)
		self.handlers[option] = (get, set)
		return [PrefTab]

class Icon_Image(g.Image):
	def __init__(self):
		g.Image.__init__(self)
    		self.pxbuf = g.gdk.pixbuf_new_from_file(rox.app_dir+"/AppIcon.xpm")
		self.get_from_file(rox.app_dir+"/AppIcon.xpm")
		self.show()
		self.setStockMissing()
	def get_from_file(self,Filename):
    		if os.path.isfile(Filename):
			del self.pxbuf
			gc.collect()
			self.pxbuf = g.gdk.pixbuf_new_from_file(Filename)
    			im_icon_set = g.IconSet(self.pxbuf)
    			self.set_from_icon_set(im_icon_set,g.ICON_SIZE_SMALL_TOOLBAR)
		else:
			self.setStockMissing()
	def get_from_uri(self,uri,file):
		self.setStockRefresh()
		try:
			urllib.urlretrieve(uri,file)
			self.get_from_file(file)
		except (IOError, EOFError):
			self.setStockCancel()
	def setStockJump(self):
		self.set_from_stock(g.STOCK_JUMP_TO,g.ICON_SIZE_SMALL_TOOLBAR)
	def setStockCancel(self):
		self.set_from_stock(g.STOCK_CANCEL,g.ICON_SIZE_SMALL_TOOLBAR)
	def setStockRefresh(self):
		self.set_from_stock(g.STOCK_REFRESH,g.ICON_SIZE_SMALL_TOOLBAR)
	def setStockConvert(self):
		self.set_from_stock(g.STOCK_CONVERT,g.ICON_SIZE_SMALL_TOOLBAR)
	def setStockMissing(self):
		self.set_from_stock(g.STOCK_MISSING_IMAGE,g.ICON_SIZE_SMALL_TOOLBAR)

class ConfigPage(g.Fixed):
        def __init__(self):
		g.Fixed.__init__(self)
		#self.entry={"ticker":ticker,"icon":iconname,"title":"",\
	    	#		"link":"","desc":"" }
		self.show
		######### set labels
		label1 = g.Label("max. Number of News to fetch")
		label1.show()
		self.put (label1, 184, 30)
		label1.set_size_request(88, 32)
		label1.set_line_wrap(True)
		label2 = g.Label("source html-adress")
		label2.show()
		self.put (label2, 8, 8)
		label2.set_size_request(-1, 16)
		label3 = g.Label("Icon html-adress")
		label3.show()
		self.put (label3, 8, 56)
		label3.set_size_request(-1, 16)
		label4 = g.Label("local Icon (or cache adress)")
		label4.show()
		self.put (label4, 8, 104)
		label4.set_size_request(-1, 16)
		self.label5 = g.Label("[ icon in cachdir - see path conf ]")
		#label5.show()
		self.put (self.label5, 8, 139)
		self.label5.set_size_request(-1, 16)
		########## set button
		button3 = g.Button("fetch to local File now")
		button3.show()
		self.put (button3, 204, 120)
		button3.set_size_request(-1,22)
		button3.connect('clicked', self.fetch_icon)
		button1 = g.EventBox()
		button1.show()
		b_image = g.Image()
		b_image.set_from_stock(g.STOCK_OPEN,g.ICON_SIZE_SMALL_TOOLBAR)
		b_image.show()
		button1.add(b_image)
		self.put (button1, 148, 104)
		#button1.set_size_request(-1,22)
		button1.connect('button_press_event', self.open_cache_file)
		########## set entrys
		self.e_ticker = g.Entry()
		self.e_ticker.show()
		self.put (self.e_ticker, 8, 24)
		self.e_ticker.set_size_request(158,22)
		self.e_icon = g.Entry()
		self.e_icon.show()
		self.put (self.e_icon, 8, 72)
		self.e_icon.set_size_request(158,22)
		self.e_iconcache = g.Entry()
		self.e_iconcache.show()
		self.put (self.e_iconcache, 8, 120)
		self.e_iconcache.set_size_request(158,22)
		######### set Spin
		self.s_maxnews = g.SpinButton(g.Adjustment(23, 0, 100, 1, 10, 10))
		self.s_maxnews.show()
		self.put (self.s_maxnews, 275, 35)
		self.s_maxnews.set_size_request(45,22)
		######### set Check
		self.c_fetchicon = g.CheckButton("fetch icon regularily")
		self.c_fetchicon.show()
		self.put (self.c_fetchicon, 184, 94)
		self.c_fetchicon.set_size_request(-1, 24)
		self.c_active = g.CheckButton("Source activated")
		self.c_active.show()
		self.put (self.c_active, 184, 8)
		self.c_active.set_size_request(-1, 24)
		########
		self.icon_image = Icon_Image()
		self.icon_image.setStockMissing()
		self.icon_image.show()
		self.put(self.icon_image, 184, 122)
		########
		#hsep = g.HSeparator()
		#hsep.show()
		#self.add(hsep)
		self.active = "0"
		self.ticker = ""
		self.icon = ""
		self.def_icon = ""
		self.iconcache = ""
		self.def_iconcache = ""
		self.maxnews = "23"
		self.fetchicon = "0"
	def open_cache_file(self, widget, event):
		def set_cache_file(widget):
			sel.hide()
			if self.iconcache <> sel.get_filename():
				self.iconcache = sel.get_filename()
				self.emit('changed_Page',self)
				self.check_iconcache(None)
		def exit(widget):
			sel.hide()
		if event.button == 1:
			sel = g.FileSelection()
			if self.iconcache <> "":
				sel.set_filename(self.iconcache)
			else: sel.set_filename(self.def_iconcache)
			sel.connect("destroy", exit)
			sel.ok_button.connect("clicked", set_cache_file)
			sel.cancel_button.connect("clicked", exit)
			sel.show()
	def activate_Signals(self):
		self.e_ticker.connect('changed',self.check_ticker)
		self.e_icon.connect('changed',self.check_icon)
		self.e_iconcache.connect('changed',self.check_iconcache)
		self.s_maxnews.connect('changed',self.check_maxnews)
		self.c_fetchicon.connect('toggled',self.check_fetchicon)
		self.c_active.connect('toggled',self.check_active)	
	def fetch_icon(self, value):
		url = self.icon
		if url == "": url = self.def_icon
		#print url
		file = self.iconcache
		if file == "": file = self.def_iconcache
		self.icon_image.get_from_uri(self.http(url),file)
	def check_maxnews(self,value):
		self.maxnews = str(int(self.s_maxnews.get_value()))
		self.emit('changed_Page',self)
	def check_fetchicon(self,value):
		self.fetchicon = str(self.c_fetchicon.get_active())
		self.emit('changed_Page',self)
	def check_active(self,value):
		self.active = str(self.c_active.get_active())
		self.emit('changed_Page',self)
	def short_dir(self,value):
		if value.find(cache_dir.value) == 0:
			return "[...]"+value[len(cache_dir.value):]
		return value
	def long_dir(self,value):
		if value.find("[...]") == 0:
			return cache_dir.value + value[5:]
		return value	
	def set_ticker(self, wert):
		self.e_ticker.set_text(wert)
		self.check_ticker(None)
	def check_ticker(self,value):
		self.ticker = self.e_ticker.get_text()
		if self.ticker.find("http://") == 0:
			#print "http"
			pos = self.ticker[8:].find("/")
			if pos <> -1: pos = pos + 8
		else:	pos = self.ticker.find("/")
		if pos <> -1: self.def_icon =  self.ticker[:pos] + "/favicon.ico"
		else:	self.def_icon =  self.ticker + "/favicon.ico"
		if self.icon == "":
			self.e_icon.set_text(self.def_icon)
			self.e_icon.modify_text(g.STATE_NORMAL,self.e_icon.get_colormap().alloc_color('grey'))
		#self.def_iconcache = tmp_name(cache_dir.value, self.ticker)
		#if self.icon == "" and self.iconcache == "":
		#	self.e_iconcache.set_text(self.short_dir(self.def_iconcache))
		#	self.label5.show()
			#self.e_iconcache.set_text(self.def_iconcache)
		#	self.e_iconcache.modify_text(g.STATE_NORMAL,self.e_iconcache.get_colormap().alloc_color('grey'))
		self.check_icon(None)
		#self.check_iconcache(None)
		self.emit('changed_Page',self)
	def set_icon(self, wert):
		self.e_icon.set_text(wert)
		#self.e_icon.modify_text(g.STATE_NORMAL,self.e_icon.get_colormap().alloc_color('black'))
		self.check_icon(None)
	def check_icon(self,value):
		tmp_icon = self.e_icon.get_text()
		if tmp_icon <> self.def_icon:
			self.icon = tmp_icon
			self.def_iconcache = tmp_name(cache_dir.value, tmp_icon)
			self.e_icon.modify_text(g.STATE_NORMAL,self.e_icon.get_colormap().alloc_color('black'))
		else: 	
			self.icon = ""
			self.def_iconcache = tmp_name(cache_dir.value, self.def_icon)
			self.e_icon.modify_text(g.STATE_NORMAL,self.e_icon.get_colormap().alloc_color('grey'))
		#print "'" + self.iconcache + "'"
		if self.iconcache == "":
			#print "self.def_iconcache " + self.def_iconcache
			self.e_iconcache.set_text(self.short_dir(self.def_iconcache))
			self.label5.show()
			#self.e_iconcache.set_text(self.def_iconcache)
			self.e_iconcache.modify_text(g.STATE_NORMAL,self.e_iconcache.get_colormap().alloc_color('grey'))
		self.check_iconcache(None)
		self.emit('changed_Page',self)
	def set_iconcache(self, wert):
		self.e_iconcache.set_text(wert)
		#self.e_iconcache.modify_text(g.STATE_NORMAL,self.e_iconcache.get_colormap().alloc_color('black'))
		self.check_iconcache(None)
	def check_iconcache(self,value):
		#print self.def_iconcache
		#text = self.e_iconcache.get_text()
		#print text.find(cache_dir.value)
		tmp_iconcache = self.e_iconcache.get_text()
		if tmp_iconcache.find("[...]") == 0: self.label5.show()
		else: self.label5.hide()
		#print self.def_iconcache
		if tmp_iconcache <> self.short_dir(self.def_iconcache):
			self.iconcache = tmp_iconcache
			self.e_iconcache.modify_text(g.STATE_NORMAL,self.e_iconcache.get_colormap().alloc_color('black'))
			#print "get Image " + self.iconcache
			self.icon_image.get_from_file(self.long_dir(self.iconcache))
		else:
			self.iconcache = ""
			self.e_iconcache.modify_text(g.STATE_NORMAL,self.e_iconcache.get_colormap().alloc_color('grey'))
			#print "get Image " + self.def_iconcache
			self.icon_image.get_from_file(self.def_iconcache)
		self.emit('changed_Page',self)
	def http(self, value):
		if value.find("://") == -1: return "http://" + value
		return value		
	def set(self,value):
		self.active = value.getElementsByTagName("active")[0].firstChild.data
		self.c_active.set_active(int(self.active))
		tick_elem = value.getElementsByTagName("ticker")[0].firstChild
		if tick_elem: tmp_ticker = tick_elem.data
		else: tmp_ticker = ""
		self.set_ticker(tmp_ticker)
		icon_elem = value.getElementsByTagName("icon")[0].firstChild
		if icon_elem:
			tmp_icon = icon_elem.data
			self.set_icon(tmp_icon)
		iconcache_elem = value.getElementsByTagName("iconcache")[0].firstChild
		if iconcache_elem:
			tmp_iconcache = iconcache_elem.data
			self.set_iconcache(tmp_iconcache)
		#self.icon_image.get_from_file(self.iconcache)
		self.maxnews = value.getElementsByTagName("maxnews")[0].firstChild.data
		self.s_maxnews.set_value(int(self.maxnews))
		self.fetchicon = value.getElementsByTagName("fetchicon")[0].firstChild.data
		self.c_fetchicon.set_active(int(self.fetchicon))
	def _to_xml(self, parent):
		doc = parent.ownerDocument
		root = doc.createElement('source')
		parent.appendChild(root)
		doc = root.ownerDocument
		node = doc.createElement('active')
		node.appendChild(doc.createTextNode(self.active))
		root.appendChild(node)
		node = doc.createElement('ticker')
		node.appendChild(doc.createTextNode(self.ticker))
		root.appendChild(node)
		node = doc.createElement('icon')
		node.appendChild(doc.createTextNode(self.icon))
		root.appendChild(node)
		node = doc.createElement('iconcache')
		#print self.iconcache
		if self.iconcache <> "":
			node.appendChild(doc.createTextNode(self.long_dir(self.iconcache)))
		else:
			node.appendChild(doc.createTextNode(""))
		root.appendChild(node)
		node = doc.createElement('maxnews')
		node.appendChild(doc.createTextNode(self.maxnews))
		root.appendChild(node)
		node = doc.createElement('fetchicon')
		node.appendChild(doc.createTextNode(self.fetchicon))
		root.appendChild(node)

def tmp_name(cache, url):
	pos = url.find("http://")
	if pos <> -1: url = url[pos+7:]
	while 1:
		pos = url.find("/")
		if pos <> -1:
			url = url[:pos] + "_" + url[pos+1:]
		else: break
	return cache + "/" + url
	
class TickPrefs_Container(g.Fixed):
	def __init__(self):
		global feeds
		feeds = []
		self.pageCount = 0
		g.Fixed.__init__(self)
		#self.pages = []
#		self.set_size_request(345,200)
		self.set_size_request(345,230)
		self.notebook = g.Notebook()
		self.notebook.show()
		self.put(self.notebook,8,32)
#		self.notebook.set_size_request(332, 164)
		self.notebook.set_size_request(332, 185)
		self.notebook.set_scrollable(True)
		#self.add_Page(None)
		#self.add_Page(None)
		button2 = g.Button("new Source")
		button2.show()
		self.put (button2, 0, 0)
		button2.set_size_request(-1,22)
		button2.connect('clicked', self.add_Page)
		########## set button
		button4 = g.Button("kill Source")
		button4.show()
		self.put (button4, 80, 0)
		button4.set_size_request(-1,22)
		button4.connect('clicked', self.kill_Page)
	def kill_Page(self, value):
		killpage = self.notebook.get_nth_page(self.notebook.get_current_page())
		change = killpage.ticker <> "" or \
			killpage.icon <> ""
		self.notebook.remove_page(self.notebook.get_current_page())
		#self.pages = []
		self.pageCount -= 1
		if change: self.emit('changed_Conti',self)
	def hello_(self, value, value2):
		self.emit('changed_Conti',self)
	def add_Page(self,value):
		newpage = ConfigPage()
		newpage.show()
		self.notebook.add(newpage)
		self.pageCount += 1
		newpage.activate_Signals()
		newpage.connect('changed_Page', self.hello_)
		self.notebook.set_current_page(self.notebook.page_num(newpage))		
	def add_Page_Set(self,value):
		newpage = ConfigPage()
		newpage.show()
		self.notebook.add(newpage)
		self.pageCount += 1
		newpage.set(value)
		newpage.activate_Signals()
		newpage.connect('changed_Page', self.hello_)		
	def get_xml(self):
		from xml.dom.minidom import Document
		doc = Document()
		root = doc.createElement('Options')
		doc.appendChild(root)
		for i in range(0, self.pageCount):
			self.notebook.get_nth_page(i)._to_xml(root)
		return doc		
	def get_value(self):
		doc = self.get_xml()
		return doc.toxml()
	def load_config(self, config):
		currentPage = self.notebook.get_current_page()
		for i in range(0,self.pageCount):
			self.notebook.remove_page(0)
		self.pageCount = 0
		from xml.dom import Node, minidom
		doc = minidom.parseString(unxml(config))
		for i in doc.getElementsByTagName("source"):
			self.add_Page_Set(i)
		if currentPage <> -1: self.notebook.set_current_page(currentPage)

gobject.signal_new("changed_Conti", TickPrefs_Container, \
	gobject.SIGNAL_RUN_LAST,gobject.TYPE_NONE, \
	(gobject.TYPE_PYOBJECT,))
		
gobject.signal_new("changed_Page", ConfigPage, \
	gobject.SIGNAL_RUN_LAST,gobject.TYPE_NONE, \
	(gobject.TYPE_PYOBJECT,))

class TickPrefs(rox.Window):
	def __init__(self):
		rox.Window.__init__(self)
		self.pages = []
		table = g.Table()
		table.show()
		self.add(table)
		fixed = TickPrefs_Container()
		fixed.show()
		table.add(fixed)

#test = TickPrefs()
#test.set(sources)
#test = TickerPrefs()
#test.show()
#test.show_all()

#test.save_config()
#rox.mainloop()
